import ijeoma.motion.Motion;
import ijeoma.motion.Parameter;
import ijeoma.motion.tween.Tween;
import controlP5.ControlEvent;
import controlP5.ControlP5;
import processing.core.PApplet;

public class Controls extends BoilerPlate {
	PApplet parent;

	// control params
	ControlP5 controlP5;
	public boolean isGuideVisible;
	public boolean isFillMeshVisible;
	public boolean isDotMeshVisible;
	public boolean isLineTrailVisible;
	public boolean isLineHairVisible;
	public boolean isLineCenterVisible;

	public float rootRadius;
	public float rootSpeed;
	public float rootScalar;
	public float rootFrameCountScalar;
	public float rootSeedNormalScalar;

	public float rootLayerRadiusOffset;
	public float rootLayerAudioScalar;
	public float rootLayerRadiusScalar;

	public float rootLayerSpeedOffset;
	public float rootLayerRadiusOscillator;
	public float rootLayerRadiusOscillatorOffset;

	public float rootFlappingSpeedOffset;
	public float rootFlappingSpeedNormal;
	public float rootMaxAngle;
	// public float rootMaxAngleRange = 1.0f;

	private Tween tweener;

	// private float tweenRootRadius = 200.0f;

	Controls(PApplet p) {
		parent = p;
	}

	public void createControls() {

		controlP5 = new ControlP5(parent);
		controlP5.setAutoDraw(false);

		int offsetX = 10;
		int offsetY = 10;

		int buttonWidth = 100;
		int buttonHeight = 20;
		int buttonMargin = 5;

		int sliderWidth = 290;
		int sliderHeight = 12;
		int sliderHeightSpread = 20;

		float inc = 130;
		float offsetScaleX = 0;

		toggleIsGuideVisible(false);
		toggleFillMesh(true);
		toggleDotMesh(false);
		toggleLineTrail(false);
		toggleLineHair(false);
		toggleLineCenter(false);

		offsetY += (buttonHeight + buttonMargin);

		controlP5.addToggle("toggleIsGuideVisible", isGuideVisible, offsetX + offsetScaleX, offsetY, buttonWidth, buttonHeight).plugTo(this);
		offsetScaleX += inc;
		controlP5.addToggle("toggleFillMesh", isFillMeshVisible, offsetX + offsetScaleX, offsetY, buttonWidth, buttonHeight).plugTo(this);
		offsetScaleX += inc;
		controlP5.addToggle("toggleDotMesh", isDotMeshVisible, offsetX + offsetScaleX, offsetY, buttonWidth, buttonHeight).plugTo(this);
		offsetScaleX += inc;
		controlP5.addToggle("toggleLineTrail", isLineTrailVisible, offsetX + offsetScaleX, offsetY, buttonWidth, buttonHeight).plugTo(this);
		offsetScaleX += inc;
		controlP5.addToggle("toggleLineHair", isLineHairVisible, offsetX + offsetScaleX, offsetY, buttonWidth, buttonHeight).plugTo(this);
		offsetScaleX += inc;
		controlP5.addToggle("toggleLineCenter", isLineCenterVisible, offsetX + offsetScaleX, offsetY, buttonWidth, buttonHeight).plugTo(this);
		offsetScaleX += inc;

		offsetY += (buttonHeight + buttonMargin);
		offsetY += (buttonHeight + buttonMargin);

		controlP5.addSlider("rootSpeed", 0.0f, 1.0f, rootSpeed, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		controlP5.addSlider("rootRadius", 0.0f, 1000.0f, rootRadius, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		controlP5.addSlider("rootScalar", 0, 100, rootScalar, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		offsetY += 20;

		controlP5.addSlider("rootFrameCountScalar", -.25f, .25f, rootFrameCountScalar, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		controlP5.addSlider("rootSeedNormalScalar", 0.0f, 10.0f, rootSeedNormalScalar, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		offsetY += 20;

		controlP5.addSlider("rootLayerRadiusOffset", 0.0f, 500.0f, rootLayerRadiusOffset, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		controlP5.addSlider("rootLayerAudioScalar", -100.0f, 100.0f, rootLayerAudioScalar, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		controlP5.addSlider("rootLayerRadiusScalar", -500.0f, 500.0f, rootLayerRadiusScalar, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		offsetY += 20;

		controlP5.addSlider("rootLayerSpeedOffset", 0.0f, 15.0f, rootLayerSpeedOffset, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		controlP5.addSlider("rootLayerRadiusOscillator", 0.0f, 5.0f, rootLayerRadiusOscillator, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		controlP5.addSlider("rootLayerRadiusOscillatorOffset", 0.0f, 5.0f, rootLayerRadiusOscillatorOffset, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);

		offsetY += 20;
		controlP5.addSlider("rootFlappingSpeedNormal", 0.0f, 1.0f, rootFlappingSpeedNormal, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		controlP5.addSlider("rootFlappingSpeedOffset", -50.0f, 50.0f, rootFlappingSpeedOffset, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);
		offsetY += 20;

		controlP5.addSlider("rootMaxAngle", 0.0f, 360.0f, rootMaxAngle, offsetX, offsetY, sliderWidth, sliderHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);

		offsetY += 20;
		controlP5.addButton("randomizeButton", 0, 10, offsetY, sliderWidth, buttonHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);

		controlP5.addButton("defaultButton", 0, 10, offsetY, sliderWidth, buttonHeight).plugTo(this);
		offsetY += (buttonHeight + buttonMargin);

		// tween class
		Motion.setup(parent);
		tweener = new Tween();

		// tweener = new Tween(0f, 400f, 100f);
		tweener.addParameter(new Parameter("rootSpeedController"));
		tweener.addParameter(new Parameter("rootRadiusController"));
		tweener.addParameter(new Parameter("rootScalarController"));

		tweener.addParameter(new Parameter("rootFrameCountScalarController"));
		tweener.addParameter(new Parameter("rootSeedNormalScalarController"));

		tweener.addParameter(new Parameter("rootLayerRadiusOffsetController"));
		tweener.addParameter(new Parameter("rootLayerAudioScalarController"));
		tweener.addParameter(new Parameter("rootLayerRadiusScalarController"));

		tweener.addParameter(new Parameter("rootLayerSpeedOffsetController"));
		tweener.addParameter(new Parameter("rootLayerRadiusOscillatorController"));
		tweener.addParameter(new Parameter("rootLayerRadiusOscillatorOffsetController"));

		tweener.addParameter(new Parameter("rootFlappingSpeedNormalController"));
		tweener.addParameter(new Parameter("rootFlappingSpeedOffsetController"));

		tweener.addParameter(new Parameter("rootMaxAngleController"));

		tweener.setDuration(150);

	}

	public void setAsDefaultSliders() {
		tracer("setAsDefaultSliders");
		changeTweenerParam("rootSpeedController", rootSpeed, 0.25f);
		changeTweenerParam("rootRadiusController", rootRadius, 400.0f);
		changeTweenerParam("rootScalarController", rootScalar, 25.0f);

		changeTweenerParam("rootFrameCountScalarController", rootFrameCountScalar, 0.0f);
		changeTweenerParam("rootSeedNormalScalarController", rootSeedNormalScalar, 0.0f);

		changeTweenerParam("rootLayerRadiusOffsetController", rootLayerRadiusOffset, 0.0f);
		changeTweenerParam("rootLayerAudioScalarController", rootLayerAudioScalar, 15.0f);
		changeTweenerParam("rootLayerRadiusScalarController", rootLayerRadiusScalar, 150.0f);

		changeTweenerParam("rootLayerSpeedOffsetController", rootLayerSpeedOffset, 5.0f);
		changeTweenerParam("rootLayerRadiusOscillatorController", rootLayerRadiusOscillator, 0.5f);
		changeTweenerParam("rootLayerRadiusOscillatorOffsetController", rootLayerRadiusOscillatorOffset, 0.75f);

		changeTweenerParam("rootFlappingSpeedNormalController", rootFlappingSpeedNormal, .125f);
		changeTweenerParam("rootFlappingSpeedOffsetController", rootFlappingSpeedOffset, 0.25f);

		changeTweenerParam("rootMaxAngleController", rootMaxAngle, 90.0f);

		tweener.play();
	}

	public void randomizeSliders() {
		tracer("randomizeSliders");
		changeTweenerParam("rootSpeedController", rootSpeed, getRandom(0.25f, 0.5f));
		changeTweenerParam("rootRadiusController", rootRadius, getRandom(300.0f, 800.0f));
		changeTweenerParam("rootScalarController", rootScalar, getRandom(25.0f, 100.0f));

		changeTweenerParam("rootFrameCountScalarController", rootFrameCountScalar, getRandom(-0.25f, 0.25f));
		changeTweenerParam("rootSeedNormalScalarController", rootSeedNormalScalar, getRandom(0.0f, 10.0f));

		changeTweenerParam("rootLayerRadiusOffsetController", rootLayerRadiusOffset, getRandom(0.0f, 100.0f));
		changeTweenerParam("rootLayerAudioScalarController", rootLayerAudioScalar, getRandom(-10.0f, 10.0f));
		changeTweenerParam("rootLayerRadiusScalarController", rootLayerRadiusScalar, getRandom(-100.0f, 100.0f));

		changeTweenerParam("rootLayerSpeedOffsetController", rootLayerSpeedOffset, getRandom(0.0f, 15.0f));
		changeTweenerParam("rootLayerRadiusOscillatorController", rootLayerRadiusOscillator, getRandom(0.0f, 5.0f));
		changeTweenerParam("rootLayerRadiusOscillatorOffsetController", rootLayerRadiusOscillatorOffset, getRandom(0.0f, 5.0f));

		changeTweenerParam("rootFlappingSpeedNormalController", rootFlappingSpeedNormal, getRandom(0.0f, 0.25f));
		changeTweenerParam("rootFlappingSpeedOffsetController", rootFlappingSpeedOffset, getRandom(-10.0f, 10.0f));

		changeTweenerParam("rootMaxAngleController", rootMaxAngle, getRandom(0.0f, 360.0f));

		tweener.play();
	}

	void randomizeButton() {
		randomizeSliders();
	}

	void defaultButton() {
		setAsDefaultSliders();
	}

	private void changeTweenerParam(String tweenString, float beginParam, float endParam) {
		tweener.getParameter(tweenString).setBegin(beginParam);
		tweener.getParameter(tweenString).setEnd(endParam);
	}

	private void changeTweenerParam(String tweenString, int beginParam, int endParam) {
		changeTweenerParam(tweenString, (float) beginParam, (float) endParam);
	}

	public void updateParams() {
		if (tweener.getSeekPosition() == 1.0f) {
			return;
		}

		controlP5.controller("rootSpeed").setValue(tweener.getParameter("rootSpeedController").getPosition());
		controlP5.controller("rootRadius").setValue(tweener.getParameter("rootRadiusController").getPosition());
		controlP5.controller("rootScalar").setValue(tweener.getParameter("rootScalarController").getPosition());

		controlP5.controller("rootFrameCountScalar").setValue(tweener.getParameter("rootFrameCountScalarController").getPosition());
		controlP5.controller("rootSeedNormalScalar").setValue(tweener.getParameter("rootSeedNormalScalarController").getPosition());

		controlP5.controller("rootLayerRadiusOffset").setValue(tweener.getParameter("rootLayerRadiusOffsetController").getPosition());
		controlP5.controller("rootLayerAudioScalar").setValue(tweener.getParameter("rootLayerAudioScalarController").getPosition());
		controlP5.controller("rootLayerRadiusScalar").setValue(tweener.getParameter("rootLayerRadiusScalarController").getPosition());

		controlP5.controller("rootLayerSpeedOffset").setValue(tweener.getParameter("rootLayerSpeedOffsetController").getPosition());
		controlP5.controller("rootLayerRadiusOscillator").setValue(tweener.getParameter("rootLayerRadiusOscillatorController").getPosition());
		controlP5.controller("rootLayerRadiusOscillatorOffset").setValue(tweener.getParameter("rootLayerRadiusOscillatorOffsetController").getPosition());

		controlP5.controller("rootFlappingSpeedNormal").setValue(tweener.getParameter("rootFlappingSpeedNormalController").getPosition());
		controlP5.controller("rootFlappingSpeedOffset").setValue(tweener.getParameter("rootFlappingSpeedOffsetController").getPosition());

		controlP5.controller("rootMaxAngle").setValue(tweener.getParameter("rootMaxAngleController").getPosition());

	}

	private void toggleIsGuideVisible(boolean theFlag) {
		isGuideVisible = theFlag;
	}

	private void toggleFillMesh(boolean theFlag) {
		isFillMeshVisible = theFlag;
	}

	private void toggleDotMesh(boolean theFlag) {
		isDotMeshVisible = theFlag;
	}

	private void toggleLineTrail(boolean theFlag) {
		isLineTrailVisible = theFlag;
	}

	private void toggleLineHair(boolean theFlag) {
		isLineHairVisible = theFlag;
	}

	private void toggleLineCenter(boolean theFlag) {
		isLineCenterVisible = theFlag;
	}

	public void draw() {
		controlP5.draw();
	}

	public void controlEvent(ControlEvent theEvent) {
		// tracer("controlEvent :: "+parent);

	}
}
